package com.ejie.ad74a.service;

import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.odftoolkit.odfdom.doc.OdfSpreadsheetDocument;
import org.odftoolkit.odfdom.doc.table.OdfTable;
import org.odftoolkit.odfdom.doc.table.OdfTableRow;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ad74a.dao.BandejaTelematicaDao;
import com.ejie.ad74a.dao.ExpedientesDao;
import com.ejie.ad74a.exceptions.ManagerErrors;
import com.ejie.ad74a.model.BandejaTelematica;
import com.ejie.ad74a.model.DocumentosBanTel;
import com.ejie.ad74a.service.tramitacion.TareaEntradaDocumentacionService;
import com.ejie.ad74a.util.comun.UtilLiterales;
import com.ejie.ad74a.util.comun.UtilSeguridad;
import com.ejie.ad74a.util.comun.UtilidadesFecha;
import com.ejie.ad74a.util.constantes.Constantes;
import com.ejie.ad74a.util.constantes.TiposDocumentoRoleEnum;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;
import com.lowagie.text.Document;
import com.lowagie.text.Phrase;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;

/**
 * BandejaTelematicaServiceImpl generated by UDA, 28-mar-2023 10:21:54.
 * 
 * @author UDA
 */

@Service(value = "bandejaTelematicaService")
public class BandejaTelematicaServiceImpl implements BandejaTelematicaService {

	private static final Logger logger = LoggerFactory.getLogger(BandejaTelematicaServiceImpl.class);

	@Autowired
	private ExpedientesDao expedientesDao;

	@Autowired
	private BandejaTelematicaDao bandejaTelematicaDao;

	@Autowired
	private DocumentosBanTelService documentosBanTelService;

	@Autowired
	private TareaEntradaDocumentacionService tareaEntradaDocumentacionService;

	@Autowired
	private ReloadableResourceBundleMessageSource appMessageSource;

	/**
	 * Inserts a single row in the BandejaTelematica table.
	 *
	 * @param bandejaTelematica BandejaTelematica
	 * @return BandejaTelematica
	 */

	@Transactional(rollbackFor = Throwable.class)
	public BandejaTelematica add(BandejaTelematica bandejaTelematica) {
		return this.bandejaTelematicaDao.add(bandejaTelematica);
	}

	/**
	 * Updates a single row in the BandejaTelematica table.
	 *
	 * @param bandejaTelematica BandejaTelematica
	 * @return BandejaTelematica
	 */
	@Transactional(rollbackFor = Throwable.class)
	public BandejaTelematica update(BandejaTelematica bandejaTelematica) {
		return this.bandejaTelematicaDao.update(bandejaTelematica);
	}

	/**
	 * Finds a single row in the BandejaTelematica table.
	 *
	 * @param bandejaTelematica BandejaTelematica
	 * @return BandejaTelematica
	 */
	public BandejaTelematica find(BandejaTelematica bandejaTelematica) {
		return (BandejaTelematica) this.bandejaTelematicaDao.find(bandejaTelematica);
	}

	/**
	 * Deletes a single row in the BandejaTelematica table.
	 *
	 * @param bandejaTelematica BandejaTelematica
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(BandejaTelematica bandejaTelematica) {
		this.bandejaTelematicaDao.remove(bandejaTelematica);
	}

	/**
	 * Finds a list of rows in the BandejaTelematica table.
	 *
	 * @param bandejaTelematica BandejaTelematica
	 * @param tableRequestDto   TableRequestDto
	 * @return List<BandejaTelematica>
	 */
	public List<BandejaTelematica> findAll(BandejaTelematica bandejaTelematica, TableRequestDto tableRequestDto) {
		return (List<BandejaTelematica>) this.bandejaTelematicaDao.findAll(bandejaTelematica, tableRequestDto);
	}

	/**
	 * Finds rows in the BandejaTelematica table using like.
	 *
	 * @param bandejaTelematica BandejaTelematica
	 * @param tableRequestDto   TableRequestDto
	 * @param startsWith        Boolean
	 * @return List<BandejaTelematica>
	 */
	public List<BandejaTelematica> findAllLike(BandejaTelematica bandejaTelematica, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return (List<BandejaTelematica>) this.bandejaTelematicaDao.findAllLike(bandejaTelematica, tableRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the BandejaTelematica table.
	 *
	 * @param tableRequestDto TableRequestDto
	 */
	public void removeMultiple(TableRequestDto tableRequestDto) {
		this.bandejaTelematicaDao.removeMultiple(tableRequestDto);
	}

	/**
	 * Filter method in the BandejaTelematica table.
	 *
	 * @param filterBandejaTelematica BandejaTelematica
	 * @param tableRequestDto         TableRequestDto
	 * @param startsWith              Boolean
	 * @return TableResponseDto<BandejaTelematica>
	 */
	public TableResponseDto<BandejaTelematica> filter(BandejaTelematica filterBandejaTelematica,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<BandejaTelematica> listaBandejaTelematica = this.bandejaTelematicaDao.findAllLike(filterBandejaTelematica,
				tableRequestDto, false);
		Long recordNum = this.bandejaTelematicaDao.findAllLikeCount(
				filterBandejaTelematica != null ? filterBandejaTelematica : new BandejaTelematica(), false);

		TableResponseDto<BandejaTelematica> tableResponseDto = new TableResponseDto<BandejaTelematica>(tableRequestDto,
				recordNum, listaBandejaTelematica);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<BandejaTelematica>> reorderSelection = this.bandejaTelematicaDao
					.reorderSelection(filterBandejaTelematica, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSelection(reorderSelection);
			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<BandejaTelematica>> reorderSeeker = this.bandejaTelematicaDao
					.reorderSelection(filterBandejaTelematica, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSeeker(reorderSeeker);
			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return tableResponseDto;
	}

	/**
	 * Búsqueda en bandeja telemática join con expedientes y solicitantes
	 * 
	 * @param filterBandejaTelematica
	 * @param tableRequestDto
	 * @return
	 */
	public TableResponseDto<BandejaTelematica> filterComplete(BandejaTelematica filterBandejaTelematica,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<BandejaTelematica> listaBandejaTelematica = this.bandejaTelematicaComplete(filterBandejaTelematica,
				tableRequestDto);

		return getTableResponseDTO(filterBandejaTelematica, tableRequestDto, startsWith, listaBandejaTelematica);
	}

	public List<BandejaTelematica> bandejaTelematicaComplete(BandejaTelematica filterBandejaTelematica,
			TableRequestDto tableRequestDto) {
		List<BandejaTelematica> listaBandejaTelematica = this.bandejaTelematicaDao
				.filterComplete(filterBandejaTelematica, tableRequestDto);
		return listaBandejaTelematica;
	}

	private TableResponseDto<BandejaTelematica> getTableResponseDTO(BandejaTelematica filterBandejaTelematica,
			TableRequestDto tableRequestDto, Boolean startsWith, List<BandejaTelematica> listaBandejaTelematica) {
		Long recordNum = this.bandejaTelematicaDao.filterCompleteCount(
				filterBandejaTelematica != null ? filterBandejaTelematica : new BandejaTelematica(), false);

		return new TableResponseDto<BandejaTelematica>(tableRequestDto, recordNum, listaBandejaTelematica);
	}

	/**
	 * Searches rows in the BandejaTelematica table.
	 *
	 * @param filterBandejaTelematica BandejaTelematica
	 * @param searchBandejaTelematica BandejaTelematica
	 * @param tableRequestDto         TableRequestDto
	 * @param startsWith              Boolean
	 * @return List<TableRowDto<BandejaTelematica>>
	 */
	public List<TableRowDto<BandejaTelematica>> search(BandejaTelematica filterBandejaTelematica,
			BandejaTelematica searchBandejaTelematica, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.bandejaTelematicaDao.search(filterBandejaTelematica, searchBandejaTelematica, tableRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in BandejaTelematica table.
	 *
	 * @param filterBandejaTelematica BandejaTelematica
	 * @param tableRequestDto         TableRequestDto
	 * @param startsWith              Boolean
	 * @return Object
	 */
	public Object reorderSelection(BandejaTelematica filterBandejaTelematica, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.bandejaTelematicaDao.reorderSelection(filterBandejaTelematica, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the BandejaTelematica table.
	 *
	 * @param filterBandejaTelematica BandejaTelematica
	 * @param tableRequestDto         TableRequestDto
	 * @param startsWith              Boolean
	 * @return TableResponseDto<JerarquiaDto<BandejaTelematica>>
	 */
	public TableResponseDto<JerarquiaDto<BandejaTelematica>> jerarquia(BandejaTelematica filterBandejaTelematica,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<JerarquiaDto<BandejaTelematica>> listaBandejaTelematica = this.bandejaTelematicaDao
				.findAllLikeJerarquia(filterBandejaTelematica, tableRequestDto);
		Long recordNum = this.bandejaTelematicaDao.findAllLikeCountJerarquia(filterBandejaTelematica, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<BandejaTelematica>>(tableRequestDto, recordNum,
				listaBandejaTelematica);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the BandejaTelematica
	 * table.
	 *
	 * @param filterBandejaTelematica BandejaTelematica
	 * @param tableRequestDto         TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<BandejaTelematica>>
	 */
	public TableResponseDto<JerarquiaDto<BandejaTelematica>> jerarquiaChildren(
			BandejaTelematica filterBandejaTelematica, TableRequestDto tableRequestDto) {
		TableResponseDto<JerarquiaDto<BandejaTelematica>> tableResponseDto = new TableResponseDto<JerarquiaDto<BandejaTelematica>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN,
				this.bandejaTelematicaDao.findAllChild(filterBandejaTelematica, tableRequestDto));
		return tableResponseDto;
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<BandejaTelematica> getMultiple(BandejaTelematica filterBandejaTelematica,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.bandejaTelematicaDao.getMultiple(filterBandejaTelematica, tableRequestDto, startsWith);
	}

	/**
	 * Devuelve un fichero en el formato deseado que contiene los datos exportados
	 * de la tabla.
	 *
	 * @param filterBandejaTelematica BandejaTelematica
	 * @param columns                 String[]
	 * @param fileName                String
	 * @param sheetTitle              String
	 * @param reportsParams           ArrayList<?>
	 * @param tableRequestDto         TableRequestDto
	 * @param request                 HttpServletRequest
	 * @param response                HttpServletResponse
	 */
	@Override
	public void generateReport(BandejaTelematica filterBandejaTelematica, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		// Accede a la DB para recuperar datos
		List<BandejaTelematica> filteredData = getDataForReports(filterBandejaTelematica, tableRequestDto);
		String extension = null;

		// Comprobar si las siguientes variables estan vacias, en caso de estarlo se las
		// asigna un valor generico
		fileName = (fileName != null && !fileName.isEmpty()) ? fileName : "report";
		sheetTitle = (sheetTitle != null && !sheetTitle.isEmpty()) ? sheetTitle
				: BandejaTelematica.class.getSimpleName();

		// Obtener el formato de fecha especifico del locale
		SimpleDateFormat formatter = DateTimeManager.getDateTimeFormat(request.getLocale());

		// Cuando no se definen columnas porque se quieren obtener todas
		if (columns == null) {
			Field[] fields = BandejaTelematica.class.getDeclaredFields();
			ArrayList<String> tempColumns = new ArrayList<String>();

			for (int i = 0; i < fields.length; i++) {
				try {
					String methodName = fields[i].getName();
					methodName = methodName.substring(0, 1).toUpperCase() + methodName.substring(1);
					BandejaTelematica.class.getMethod("get" + methodName);
					tempColumns.add(fields[i].getName());
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}

			}
			columns = tempColumns.toArray(new String[0]);
		}

		// si no se definen el nombre de las columnas , se dejan las de por defecto.
		if (columnsName == null) {
			columnsName = columns;
		}

		String servletPath = request.getServletPath();
		String reportType = null;
		if (servletPath.contains("/") && (servletPath.lastIndexOf("/") + 1 != servletPath.length())) {
			reportType = servletPath.substring(servletPath.lastIndexOf("/") + 1, servletPath.length());
		} else {
			reportType = servletPath.substring(0, servletPath.length());
		}

		if (reportType.equals("xlsReport")) {
			extension = ".xls";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("xlsxReport")) {
			extension = ".xlsx";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("pdfReport")) {
			extension = ".pdf";
			generatePDFReport(filteredData, columns, columnsName, fileName, response);
		} else if (reportType.equals("odsReport")) {
			extension = ".ods";
			generateODSReport(filteredData, columns, columnsName, fileName, sheetTitle, response);
		} else if (reportType.equals("csvReport")) {
			extension = ".csv";
			// Obtener idioma
			String language = request.getLocale().getLanguage();
			generateCSVReport(filteredData, columns, columnsName, fileName, sheetTitle, language, response);
		}

	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<BandejaTelematica>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param extension    String
	 * @param formatter    SimpleDateFormat
	 * @param response     HttpServletResponse
	 */
	private void generateExcelReport(List<BandejaTelematica> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String extension, SimpleDateFormat formatter,
			HttpServletResponse response) {
		try {
			// Creacion del Excel
			Workbook workbook = null;
			if (extension == ".xlsx") {
				workbook = new XSSFWorkbook();
				response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			} else {
				workbook = new HSSFWorkbook();
				response.setContentType("application/vnd.ms-excel");
			}

			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + extension + "");

			// Creacion de una hoja y asignacion de su nombre
			Sheet sheet = workbook.createSheet(sheetTitle);

			// Se crea una fuente para estilizar las cabeceras
			Font headerFont = workbook.createFont();
			headerFont.setBold(true);
			headerFont.setFontHeightInPoints((short) 12);

			// Se crea un CellStyle con la fuente
			CellStyle headerCellStyle = workbook.createCellStyle();
			headerCellStyle.setAlignment(HorizontalAlignment.CENTER);
			headerCellStyle.setFont(headerFont);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Se crea la fila para insertar los titulos de las columnas
			Row row = sheet.createRow(rowNumber++);

			// Añadir titulos
			for (int i = 0; i < columnsName.length; i++) {
				Cell cell = row.createCell(i);
				cell.setCellValue(columnsName[i]);
				cell.setCellStyle(headerCellStyle);
			}

			// CreationHelper ayudara a mantener la compatibilidad del DataFormat tanto si
			// se crea un .xls como un .xlsx
			CreationHelper createHelper = workbook.getCreationHelper();

			// Se crea un CellStyle para añadir el formateador de fechas
			CellStyle dateCellStyle = workbook.createCellStyle();
			dateCellStyle.setDataFormat(createHelper.createDataFormat().getFormat(formatter.toPattern()));

			// Añadir datos
			for (BandejaTelematica rowBandejaTelematica : filteredData) {
				int cellNumber = 0;
				row = sheet.createRow(rowNumber++);

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					Cell cellBandejaTelematica = row.createCell(cellNumber++);
					cellBandejaTelematica.setCellValue(getCellValue(column, rowBandejaTelematica));
				}
			}

			// Se adapta el ancho de las columnas al contenido
			for (int i = 0; i < columns.length; i++) {
				sheet.autoSizeColumn(i);
			}

			// Se añade el fichero excel al response
			workbook.write(response.getOutputStream());
			workbook.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<BandejaTelematica>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param response     HttpServletResponse
	 */
	private void generatePDFReport(List<BandejaTelematica> filteredData, String[] columns, String[] columnsName,
			String fileName, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".pdf");
			response.setContentType("application/pdf");

			Document document = new Document();
			// Se añade el fichero pdf al response
			PdfWriter.getInstance(document, response.getOutputStream());

			document.open();

			PdfPTable table = new PdfPTable(columns.length);

			for (String column : columnsName) {
				PdfPCell header = new PdfPCell();
				header.setBorderWidth(2);
				header.setPhrase(new Phrase(column));
				table.addCell(header);
			}

			// Añadir datos
			for (BandejaTelematica rowBandejaTelematica : filteredData) {
				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					table.addCell(getCellValue(column, rowBandejaTelematica));
				}
			}

			document.add(table);
			document.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<BandejaTelematica>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param response     HttpServletResponse
	 */
	private void generateODSReport(List<BandejaTelematica> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, HttpServletResponse response) {
		try {
			// Se añade el fichero ods al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".ods");
			response.setContentType("application/vnd.oasis.opendocument.spreadsheet");

			OdfSpreadsheetDocument ods = OdfSpreadsheetDocument.newSpreadsheetDocument();
			ods.getOrCreateDocumentStyles();

			// Hay que eliminar la hoja que se genera por defecto
			ods.getTableByName("Sheet1").remove();

			// Hoja nueva
			OdfTable table = OdfTable.newTable(ods, filteredData.size() + 1, columns.length);
			table.setTableName(sheetTitle);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Cabeceras
			OdfTableRow row = table.getRowByIndex(rowNumber++);
			for (int i = 0; i < columnsName.length; i++) {
				row.getCellByIndex(i).setStringValue(columnsName[i]);
			}

			// Añadir datos
			for (BandejaTelematica rowBandejaTelematica : filteredData) {
				row = table.getRowByIndex(rowNumber++);
				int cellNumber = 0;

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					row.getCellByIndex(cellNumber++).setStringValue(getCellValue(column, rowBandejaTelematica));
				}
			}

			// Se añade el fichero ods al response
			ods.save(response.getOutputStream());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<BandejaTelematica>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param language     String
	 * @param response     HttpServletResponse
	 */
	private void generateCSVReport(List<BandejaTelematica> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String language, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".csv");
			response.setContentType("text/csv");

			// Separador de campos dependiendo del idioma
			String separator = ";";
			if (language.equals("en")) {
				separator = ",";
			}

			// Se añade el fichero csv al response
			OutputStream out = response.getOutputStream();
			// Añadir titulos
			boolean addTitles = true;

			// Añadir datos
			for (BandejaTelematica rowBandejaTelematica : filteredData) {
				int cellNumber = 1;
				StringBuilder columnsTitles = new StringBuilder();
				StringBuilder row = new StringBuilder();

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					String cellValue = getCellValue(column, rowBandejaTelematica);

					if (cellNumber < columns.length) {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"");
							columnsTitles.append(separator);
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"");
						row.append(separator);
						cellNumber++;
					} else {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"\n");
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"\n");
					}
				}

				if (addTitles) {
					out.write(columnsTitles.toString().getBytes());
					addTitles = false;
				}
				out.write(row.toString().getBytes());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve los datos recuperados de la DB.
	 *
	 * @param filterBandejaTelematica BandejaTelematica
	 * @param tableRequestDto         TableRequestDto
	 */
	private List<BandejaTelematica> getDataForReports(BandejaTelematica filterBandejaTelematica,
			TableRequestDto tableRequestDto) {
		if (tableRequestDto.getMultiselection().getSelectedAll()
				&& tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			if (filterBandejaTelematica != null) {
				return this.bandejaTelematicaDao.findAllLike(filterBandejaTelematica, tableRequestDto, false);
			} else {
				return this.bandejaTelematicaDao.findAll(new BandejaTelematica(), null);
			}
		} else {
			return this.bandejaTelematicaDao.getMultiple(filterBandejaTelematica, tableRequestDto, false);
		}
	}

	/**
	 * Obtiene los valores de las celdas.
	 *
	 * @param column               String
	 * @param rowBandejaTelematica BandejaTelematica
	 */
	private String getCellValue(String column, BandejaTelematica rowBandejaTelematica) {
		String cellValue = "";
		try {
			cellValue = BeanUtils.getProperty(rowBandejaTelematica, column) != null
					? BeanUtils.getProperty(rowBandejaTelematica, column)
					: "";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		}

		return cellValue;
	}

	/**
	 * Procesar la entrada
	 */
	@Transactional(rollbackFor = Throwable.class)
	public BandejaTelematica procesarEntrada(BandejaTelematica bandeja) throws Throwable {

		try {

			// recuperar entrada y comprobar que no esta aceptada
			BandejaTelematica banTemp = new BandejaTelematica();
			banTemp.setIdEntrada14(bandeja.getIdEntrada14());
			banTemp = this.bandejaTelematicaDao.find(banTemp);

			if (banTemp.getEstado14().equalsIgnoreCase(Constantes.EstadosBandejaTelematica.ACEPTADO)) {
				ManagerErrors.manageError(UtilLiterales.getLiteralMessage(appMessageSource, "error.entradaProcesada"));
			}

			// comprobar que todos los documentos están tipificados
			DocumentosBanTel documentoBanTel = new DocumentosBanTel();
			// BandejaTelematica bandejaAux = new BandejaTelematica();
			// bandejaAux.setIdEntrada14(bandeja.getIdEntrada14());
			// documentoBanTel.setBandejaTelematica(bandejaAux);
			documentoBanTel.setIdEntrada15(bandeja.getIdEntrada14());
			List<DocumentosBanTel> documentosList = this.documentosBanTelService.findAllLike(documentoBanTel, null,
					false);
			boolean existsSolicitud = false;
			for (DocumentosBanTel documento : documentosList) {
				if (documento.getIdTipodoc15() == null || documento.getIdTipodoc15() == 0) {
					ManagerErrors.manageError(
							UtilLiterales.getLiteralMessage(appMessageSource, "error.documentosNoTipificados"));
				}

				if (documento.getRoleid15().equalsIgnoreCase(TiposDocumentoRoleEnum.SOLICITUD.getRoleID())) {
					existsSolicitud = true;
				}
			}

			// Uno de los doucmento ha de estar tipificado como SOLICITUD
			if (!existsSolicitud) {
				ManagerErrors.manageError(
						UtilLiterales.getLiteralMessage(appMessageSource, "error.documentoSolicitudObligatorio"));
			}

			// marcamos la entrada como procesada
			bandeja.setEstado14(Constantes.EstadosBandejaTelematica.ACEPTADO);
			this.expedientesDao.updateUrgenciaExpedientebyId(bandeja);
			BandejaTelematicaServiceImpl.logger.info("BandejaTelematicaServiceImpl.procesarEntrada - Inicio");

			// Procesamos la entrada de documentación
			tareaEntradaDocumentacionService.procesarEntradaDocumentacion(bandeja);

			// actualizamos la entrada
			bandeja.setUsuModif14(UtilSeguridad.getUsuarioConectado().getUserName());
			bandeja.setfProceso14(UtilidadesFecha.getFechaSistema());
			this.bandejaTelematicaDao.updateProcesado(bandeja);

		} catch (Throwable e) {
			ManagerErrors.manageException(e,
					UtilLiterales.getLiteralMessage(appMessageSource, "error.procesarEntrada"));
		}

		BandejaTelematicaServiceImpl.logger.info("BandejaTelematicaServiceImpl.procesarEntrada - Fin");

		return bandeja;
	}

}
